var $ = window.KPMjQuery.noConflict();
UI.SetUpLocalizations();

// [TODO] move this to UI
window.document.addEventListener('kpm_form_handled', function(event){
    // [FIXME] this condition accepts too many events, but if no locked check, masterpass doesn't work
    // if(UI.locked == 0 && KPM.formsFound == 0)
    //     return;
    
    if(window.shouldhave.accounts == false &&
       window.shouldhave.identities == false &&
       window.shouldhave.recentAccounts == false &&
       window.shouldhave.masterpass == false)
    {
        window.document.addEventListener('kpm_formHandlingDone', function(){
            var evnt = new CustomEvent('kpm_formHandlingDoneTrue', {});        
            window.document.dispatchEvent(evnt);
        }, false);
        
        BrowserSpecific.dispatchMessage('kpm_popover_update', { baseUnlocked: 2, pageKey: BrowserSpecific.GetDocument().location.href, url: BrowserSpecific.GetDocument().location.href});
    }
    
    // KPM.formsHandled++;
    // //console.log('counting handled forms : ' + KPM.formsHandled + ' / ' + KPM.formsFound);
    // if(KPM.formsHandled == KPM.formsFound)
    // {
    //     //console.log('makign listener');
    //     window.document.addEventListener('kpm_formHandlingDone', function(){
    //         //console.log('firing listener');
    //         
    //         var evnt = new CustomEvent('kpm_formHandlingDoneTrue', {});        
    //         window.document.dispatchEvent(evnt);
    //     }, false);
    //     // BrowserSpecific.dispatchMessage('kpm_pageLoaded', {});        
    // }
}, false);

// [FIXME] Get rid of global object
if(typeof(window.shouldhave) == 'undefined')
    window.shouldhave = {
        accounts: false,
        identities: false,
        recentAccounts: true,
        masterpass: false
    };

var KPM = {    
    originalSubmitHandlers: {},
  
    formsFound: 0,
    formsHandled: 0,
    
    masterPassConnectionExists: false,
    requestsData: {},
    ParseDOMBody: function()
    {                       
        KPM.formsHandled = 0;

        // Find complete forms
        var formObjects = FormsParser.findFormsInDOM();
        // if(KPM.formsFound != formObjects.length)
        {
            KPM.formsFound += formObjects.length;
            for(var i = 0; i < formObjects.length; i++)
            {
                var template = FormsParser.parseFormObject(formObjects[i]);                
                if(template['form_fields'].length != 0)
                {
                    template.formIndexInDOM = i;                    
                    BrowserSpecific.handleParsedFormObject(template);
                    // if(template.kpm_templateId == 'simpleLoginPasswordCheckboxForm')
                    //     KPM.SetUpFormFillingEventListener(template);
                    
                    if(template.kpm_templateId == 'simpleLoginPasswordCheckboxForm' || 
                       template.kpm_templateId == 'signupTemplate')
                    {
                        KPM.SetUpFormFillingEventListener(template);
                    }
                        
                    if(template.kpm_templateId == 'simpleLoginPasswordCheckboxForm')
                        window.shouldhave.accounts = true;
                    else if(template.kpm_templateId != 'empty_form')
                        window.shouldhave.identities = true;
                }
            }
        }       
        
        // Find separate inputs
        // var separateInputs = FormsParser.findSeparateInputsInDOM();
        // for(var i = 0; i < separateInputs.length; i++)
        // {
        //     var template = FormsParser.tryFindSmthUseful(separateInputs[i]);
        //     if(template['form_fields'].length != 0)
        //     {
        //         BrowserSpecific.handleParsedFormObject(template);
        //         KPM.SetUpFormFillingEventListener(template);                
        //     }
        // }
    },
    ParseDOM: function()
    {        
        if(typeof window.KPM === 'undefined')
            window.KPM = {};
            
        if(typeof window.KPM.DOMParsed === 'undefined')
        {
            window.KPM.DOMParsed = 'yes';            
            if(typeof window.location.href === 'undefined')
                return;
            
            UI.CleanPageAndPopover();
        
            if(typeof window.KPM.observer === 'undefined' &&
               (typeof WebKitMutationObserver !== 'undefined' || typeof MutationObserver !== 'undefined'))
            {
                var MutationObserberObject = (typeof WebKitMutationObserver === 'undefined')?MutationObserver:WebKitMutationObserver;            
                window.KPM.observer = new MutationObserberObject(function(mutations)
                {
                    setTimeout(function(){
                        mutations.forEach(function(mutation)
                        {
                            for (var i = 0; i < mutation.addedNodes.length; i++)
                            {
                                if($(mutation.addedNodes[i]).find('form').length > 0 || document.forms.length > 0)
                                {
                                    KPM.ParseDOMBody();
                                    setTimeout(function(){
                                        if(UI.locked == 0)
                                        {
                                            var evnt = new CustomEvent('kpm_mutation_updatepopover_event', {});
                                            window.document.dispatchEvent(evnt);
                                        }
                                    }, 100);
                                    break;
                                }
                            }
                        })    
                    }, 100);
                });
                window.KPM.observer.observe(document.body, { childList: true });
            }
            
            KPM.ParseDOMBody();
        }
    },
    FillForm: function(filledTemplate)
    {     
        if(typeof(filledTemplate['form_fields']) == 'string')
            filledTemplate['form_fields'] = KPMjQuery.parseJSON(filledTemplate['form_fields']);
        FormsParser.fillFormInDOM(filledTemplate);
        
        // Ask global page if it is needed to perform autologin
        if(filledTemplate.kpm_templateId == 'simpleLoginPasswordCheckboxForm' && filledTemplate['autoActivation'])
        {

            BrowserSpecific.GetDocument().addEventListener('kpm_shouldPerformAutologinResponse', function(e){                
                filledTemplate['autoActivation'] = false;
                // Firefox == string
                if(typeof e.detail == 'string' || e.detail.shouldPerform == 1)
                    KPM.SubmitForm(filledTemplate);
            }, false);
            BrowserSpecific.dispatchMessage('kpm_shouldPerformAutologin', { pageKey : BrowserSpecific.GetDocument().location.href });            
        }
    },
    eventRequestListener: function(event) {
        var splitType = event.type.split('_')[1];
        if(typeof(event) != 'undefined' && typeof(event.detail) != 'undefined' && event.detail != null && typeof(event.detail.removeListener) != 'undefined')
            this.removeEventListener(event.type, arguments.callee, false);
        else        
        {    
            KPM.requestsData[splitType].anotherFormIndex
            var allForms = BrowserSpecific.GetDocument().forms;
            if(KPM.requestsData[splitType].anotherFormIndex >= allForms.length) // no form
                return;                
                
            BrowserSpecific.dispatchMessage('kpm_' + splitType + '_response', {  variants   : KPM.requestsData[splitType].variants,
                                                                                 form_index : KPM.requestsData[splitType].anotherFormIndex,
                                                                                 event_name : KPM.requestsData[splitType].callbackName    });                                                                                 
        }
    },
    masterpassEventCallbackListener: function(event) {     
        var splitType = event.type.split('_')[1];        
        if(typeof(event) != 'undefined' && typeof(event.detail) != 'undefined' && event.detail != null && typeof(event.detail.removeListener) != 'undefined')
            this.removeEventListener(KPM.requestsData[splitType].callbackName, arguments.callee, false);
        else
        {
            if(typeof event.detail == 'string') // [FIXME] this looks like a solution for Firefox 17 popover problem...
                var detail = JSON.parse(event.detail);
            else
                var detail = event.detail;

                try
                {
                    KPM.requestsData[splitType].customCallback(detail.value);  // this is master password specific
                }
                catch(e)
                {
                    // [FIXME] 
                }
            $('.kpm_dialogOuterBoxAssigned').remove();                    
        }
    },
    masterpassEventNoCallbackListener: function(event) {
        var splitType = event.type.split('_')[1];
        if(typeof(event) != 'undefined' && typeof(event.detail) != 'undefined' && event.detail != null && typeof(event.detail.removeListener) != 'undefined')
            this.removeEventListener(KPM.requestsData[splitType].callbackName, arguments.callee, false);
        else                
        {
            if(typeof event.detail == 'string') // [FIXME] this looks like a solution for Firefox 17 popover problem...
                var detail = JSON.parse(event.detail);
            else
                var detail = event.detail;
                
            if(BrowserSpecific.plugin()[callback])
                BrowserSpecific.plugin()[callback]([detail.value], detail.form_index);
            $('.kpm_dialogOuterBoxAssigned').remove();                    
        }
    },
    SetUpConnectionWithPopover: function(variantsArg, type, callbackName, customCallback) // [TODO] move this to UI
    {        
        var variants = [];
        var anotherFormIndex = variantsArg[0];
            
        for(var i = 1; i < variantsArg.length; i++)
        {
            // injecting primary key and optional account
            // [TODO] keep DRY with UI.js
            if(typeof(variantsArg[i]['value']) != 'undefined' && variantsArg[i]['value'] == '')
                continue;
            if(typeof(variantsArg[i]['value']) != 'undefined' && variantsArg[i]['value'] != '')
                variants.push({value : variantsArg[i]['value'],
                               html  : variantsArg[i]['html']});                    
            else
                variants.push({value : variantsArg[i][0],
                               html  : variantsArg[i][0]});
        }
        
        KPM.requestsData[type] = { variants         : variants,
                                   callbackName     : callbackName,
                                   customCallback   : customCallback,
                                   anotherFormIndex : anotherFormIndex };
        
        window.document.addEventListener('kpm_' + type + '_request', KPM.eventRequestListener, false);
        if(typeof(customCallback) != 'undefined')
            window.document.addEventListener(callbackName, KPM.masterpassEventCallbackListener, false);
        else
            window.document.addEventListener(callbackName, KPM.masterpassEventNoCallbackListener, false);
                    
        window.shouldhave[type] = false;
        var evnt = new CustomEvent('kpm_form_handled', {});        
        window.document.dispatchEvent(evnt);        
    },
    TellPopoverPasswordIsIncorrect: function()
    {
        BrowserSpecific.dispatchMessage('kpm_wrong_password', {});
    },
    // DispatchFavoriteAccountsToPopover: function()
    // {
    //     var array = [];
    //     array.push(-1);
    //     for(var obj in arguments)
    //         array.push({value: arguments[obj][1], html: arguments[obj][0]});
    //     KPM.SetUpConnectionWithPopover(array, 'favoriteAccounts', 'kpm_favoriteAccounts_fill_data');        
    // },
    DispatchAllWebAccountsToPopover: function()
    {
        var array = [];
        array.push(-1);
        for(var obj in arguments)
            array.push({value: arguments[obj][1], html: arguments[obj][0]});
        KPM.SetUpConnectionWithPopover(array, 'allWebAccounts', 'kpm_allWebAccounts_fill_data');        
    },
    DispatchRecentAccountsToPopover: function()
    {
        var array = [];
        array.push(-1);
        for(var obj in arguments)
            array.push({value: arguments[obj][1], html: arguments[obj][0]});
        KPM.SetUpConnectionWithPopover(array, 'recentAccounts', 'kpm_recentAccounts_fill_data');
        
        // BrowserSpecific.dispatchMessage('kpm_popover_update', {baseUnlocked : 1, requestType: 'recentAccounts'});        
    },    
    DispatchIdentitiesToPopover: function() // [TODO] move this to UI
    {
        KPM.SetUpConnectionWithPopover(arguments, 'identities', 'kpm_identities_fill_data');
        // BrowserSpecific.dispatchMessage('kpm_popover_update', {baseUnlocked : 1, requestType : 'identities'});        
    },
    AskUser: function() // [TODO] move this to UI
    {
        KPM.SetUpConnectionWithPopover(arguments, 'accounts', 'kpm_accounts_fill_data');        
        UI.AskForSelection(arguments);        
    },
    SetUpFormFillingEventListener: function(template) // This is form-type specific
    {        
        if(typeof template['action'] === 'undefined' || template['action'].length === 0)
            var allForms = $('form');
        else
            var allForms = $('form[action=\'' + template['action'] + '\']');
        allForms.each(function(el){
            
            var formSubmissionHandler = function(formToHandle, objToHandle, userAct) {                    
                template = KPM.FillTemplateData(template);                                        
                FormsParser.fillFormInDOM(template);                    
                                
                if(typeof kpm_originalSubmitHandlers[$(formToHandle).attr('action')] === 'undefined' || kpm_originalSubmitHandlers[$(formToHandle).attr('action')].value == false)
                {   
                    kpm_originalSubmitHandlers[$(formToHandle).attr('action')].value = 'once';
                    (function(anotherForm, template){
                        var updatedData = { templateType : template.kpm_templateId };
                        for(var i = 0; i < template['form_fields'].length; i++)
                        {
                            if(typeof template['form_fields'][i]['input_name'] !== 'undefined')
                                updatedData[template['form_fields'][i]['kpm_type']] = $(anotherForm).find('input[name=\'' + template['form_fields'][i]['input_name'] + '\']').val();                                                                        
                            else if(typeof template['form_fields'][i]['input_id'] !== 'undefined')
                                updatedData[template['form_fields'][i]['kpm_type']] = $(anotherForm).find('input[id=\'' + template['form_fields'][i]['input_id'] + '\']').val();                                                                        
                            else
                                updatedData[template['form_fields'][i]['kpm_type']] = '';
                        }
                            
                        var shouldUpdate = updatedData.templateType == 'signupTemplate'?false:true;
                        for(var i in updatedData)
                        {
                            if(i == 'templateType') continue;
                            // Do not even try to save identities with empty name or email
                            if(updatedData.templateType == 'signupTemplate' && (i.toLowerCase().indexOf('name') !== -1 || i.toLowerCase().indexOf('mail') !== -1))
                                if(typeof updatedData[i] != 'undefined' && updatedData[i].length > 0) { shouldUpdate = true; break; }
                        }
                        
                        if(shouldUpdate)    
                            BrowserSpecific.plugin()[askIfSaveNewLoginPasswordCallback](updatedData, template);            
                    })(formToHandle, template);
                    return false;
                }
                else if(kpm_originalSubmitHandlers[$(formToHandle).attr('action')].value == true)
                {               
                    // submit original form, closure is king
                    $(originalForm).removeClass('kpm_original_form_hidden');
                    $(originalForm).show();
                    $(fakeForm).hide();                        

                    // // 5
                    // $(originalForm).find('input[type=\'submit\']').click();
                    // $(originalForm).submit();                        
                    // $(originalForm)[0].submit();
                    
                    $(originalForm).find('input[type=\'submit\'],input[type=\'image\'],button,a[id*=\'subm\'],a[id*=\'Subm\'],div[id*=\'subm\'],div[id*=\'Subm\']').each(function(){
                        $(this).click();
                    });

                    return false;
                }
                return false;
            };
            
            if(typeof $(allForms[el]).attr('action') != 'undefined' && $(allForms[el]).attr('action').indexOf('_kpm_fake_form') != -1)
                return;
            if($(typeof $(allForms[el]).attr('action') != 'undefined' && 'form[action=\'' + $(allForms[el]).attr('action') + '_kpm_fake_form' + '\']').length > 0)
                return;

            var originalForm = $(allForms[el]).clone(true);
            var fakeForm = $(allForms[el]);
            
            $(fakeForm)[0].submit = function(){return false;};
            $(fakeForm).find('button').each(function(){
                $(this).click(function(){
                    $(this).parents('form').submit();
                    return false;
                });
            });

            $(fakeForm).attr('onsubmit', '');            
            if(typeof $(fakeForm).attr('action') != 'undefined')
                $(fakeForm).attr('action', $(fakeForm).attr('action') + '_kpm_fake_form');                        
            else
                $(fakeForm).attr('action', '_kpm_fake_form');                                    
                
            if(typeof window.kpm_originalSubmitHandlers == 'undefined')            
                window.kpm_originalSubmitHandlers = {};
            window.kpm_originalSubmitHandlers[$(fakeForm).attr('action')] = {};            
            window.kpm_originalSubmitHandlers[$(fakeForm).attr('action')].value = false;
                        
            $(fakeForm).each(function(){
                var thisFakeForm = this;
                
                $(this).submit(function(){
                    var thisObj = this;                    
                    return formSubmissionHandler(thisFakeForm, thisObj, 'submit');
                });
                $(this).find('input[type=\'image\'],a[id*=\'subm\'],a[id*=\'Subm\'],div[id*=\'subm\'],div[id*=\'Subm\']').each(function(){
                    var thisObj = this;                    
                    $(this).click(function(){
                        return formSubmissionHandler(thisFakeForm, thisObj, 'click');
                    }); 
                });
                // $(this).find('input[type=\'image\'],button,a[class*=\'subm\'],a[id*=\'Subm\'],div[id*=\'subm\'],div[id*=\'Subm\']').each(function(){
                //     var thisObj = this;
                //     $(this).keypress(function(event){
                //         if (event.which == 13)                           
                //             return formSubmissionHandler(thisFakeForm, thisObj, 'keypress');
                //     }); 
                // });                           
            });
            
            $(allForms[el]).after(originalForm);                                    
            
            $(originalForm).hide();
            $(originalForm).addClass('kpm_original_form_hidden');
                        
            return;
        });                 
    },
    FillTemplateData: function(template, gatherOrigianlForm)
    {
        for(var i = 0; i < template['form_fields'].length; i++)
        {
            if(typeof gatherOrigianlForm != 'undefined' && gatherOrigianlForm)
                var ifFake = '';
            else
                var ifFake = '_kpm_fake_form';
            $('form[action=\'' + template['action'] + ifFake + '\']').each(function(){                
                var dataFieldElement = $(this).find('[name=\'' + template['form_fields'][i]['input_name'] + '\']');
                
                if(typeof $(dataFieldElement).attr('type') !== 'undefined' && $(dataFieldElement).attr('type').toLowerCase() === 'radio')
                {
                    $(dataFieldElement).each(function(){
                        if($(this)[0].checked)
                            template['form_fields'][i]['kpm_value'] = $(this).attr('value');
                    });
                    return;
                }
                if($(dataFieldElement)[0].nodeName.toLowerCase() === 'select')
                {
                    $(dataFieldElement).find('option').each(function(){
                        if($(this)[0].selected)
                            template['form_fields'][i]['kpm_value'] = $(this).attr('value');  
                    });
                    return;
                }
                
                // else
                {
                    $(dataFieldElement).each(function(){
                        if(typeof $(this).val() !== 'undefined' && $(this).val().length > 0)
                            template['form_fields'][i]['kpm_value'] = $(this).val();                         
                    });
                }
            });            
        }                
        return template;    
    },    
    UpdateDatabase: function(template, addNewAccount)
    {
        template = KPM.FillTemplateData(template, true);        
        BrowserSpecific.UpdateDatabase(template);   
        KPM.SubmitForm(template);
    },
    DoNotUpdateDatabase: function(template)
    {
        // [TODO] check form template for do not save option
        // [TODO] store do not save option somewhere        
        // BrowserSpecific.UpdateDatabase({ doNotUpdateDatabase : true });                
        
        for(var i = 0; i < template['form_fields'].length; i++)
            template['form_fields'][i]['kpm_value'] = $('input[name=\'' + template['form_fields'][i]['input_name'] + '\']').val();
        KPM.SubmitForm(template);
    },
    SubmitForm: function(template)
    {
        KPM.FillForm(template);
        
        // Submit form, only if something filled
        for(var field in template['form_fields'])
        {
            var yaiv = $('input[name=\'' + template['form_fields'][field]['input_name'] + '\']').val();
            var yait = $('input[name=\'' + template['form_fields'][field]['input_name'] + '\']').attr('type');
            if(typeof yait == 'undefined')
                yait = '';
                
            if(((typeof yaiv != 'undefined' && yaiv.length > 0) &&
                (yait.toLowerCase() != 'checkbox')) ||
              (typeof template['form_fields'][field]['kpm_value'] !== 'undefined' && template['form_fields'][field]['kpm_value'].length > 0))
            {
                if(typeof window.kpm_originalSubmitHandlers == 'undefined')
                    window.kpm_originalSubmitHandlers = {};
                
                var handlerId = template['action'] + '_kpm_fake_form';
                    
                if(typeof window.kpm_originalSubmitHandlers[handlerId] == 'undefined')
                    window.kpm_originalSubmitHandlers[handlerId] = {};
                window.kpm_originalSubmitHandlers[handlerId].value = true;

                $('form[action=\'' + handlerId + '\']').submit();
                break;                
            }
        }
    }
};
